<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'LightningHero',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    darkMode: {
      type: Boolean,
      required: false,
      default: true,
    },
    centered: {
      type: Boolean,
      required: false,
      default: false,
    },
    icons: {
      type: Array,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      setIcons: this.data.icons || [
        {
          name: 'bulb-bolt-96px',
          variant: 'image',
        },
        {
          name: 'code-96px',
          variant: 'image',
        },
        {
          name: 'celebrate-icon_celebrate-96px',
          variant: 'image',
        },
        {
          name: 'tee-96px',
          variant: 'image',
        },
      ],
    };
  },
});
</script>

<template>
  <div :class="darkMode ? 'kc-hero' : 'kc-hero--light'">
    <SlpContainer>
      <SlpRow :class="`slp-mt-96 ${centered ? 'kc-hero--centered' : ''}`">
        <SlpColumn :cols="7">
          <SlpTypography
            variant="body2-bold"
            tag="p"
            class="slp-pb-24 slp-pr-sm-32"
            :class="darkMode ? 'kc-hero__accent' : ''"
          >
            {{ data.accent }}
          </SlpTypography>
          <SlpTypography
            variant="heading1-bold"
            tag="h1"
            class="slp-pb-32 slp-pr-32"
            :class="darkMode ? 'kc-hero__headline' : ''"
          >
            {{ data.headline }}
          </SlpTypography>
          <SlpButton
            v-if="data.cta?.text"
            :variant="darkMode ? 'secondary' : 'primary'"
            :href="data.cta.externalUrl"
            :data-ga-name="data.cta.dataGaName"
            :data-ga-location="data.cta.dataGaLocation"
            class="slp-mb-32"
            >{{ data.cta.text }}</SlpButton
          >
        </SlpColumn>
        <SlpColumn :cols="5" class="slp-mb-96">
          <div
            :class="
              darkMode
                ? 'kc-hero-list kc-hero-list--dark'
                : 'kc-hero-list kc-hero-list--light'
            "
          >
            <SlpTypography
              variant="body1-bold"
              tag="p"
              :class="
                darkMode
                  ? 'kc-hero-list__heading'
                  : 'kc-hero-list__heading kc-hero-list__heading--light'
              "
            >
              {{ data.subHeading }}
            </SlpTypography>
            <ul>
              <li
                v-for="(item, index) in data.list"
                :key="index"
                :class="
                  darkMode
                    ? 'kc-hero-list__item'
                    : 'kc-hero-list__item kc-hero-list__item--light'
                "
              >
                <img
                  v-if="setIcons[index] && setIcons[index].variant === 'image'"
                  :src="`/nuxt-images/icons/events/${setIcons[index].name}.svg`"
                  alt=""
                  class="kc-hero-list__icon"
                />
                <SlpIcon
                  v-else-if="setIcons[index]?.name"
                  :name="setIcons[index].name"
                  :variant="setIcons[index].variant"
                  size="md"
                  class="kc-hero-list__icon"
                />
                {{ item }}
              </li>
            </ul>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.kc-hero {
  background: linear-gradient(105.1deg, #000001 0%, #140123 86.48%);

  &--centered {
    align-items: center;

    @media (min-width: $breakpoint-lg) {
      .slp-col-md-7 {
        margin-top: -65px;
      }
    }
  }

  &--light {
    background: linear-gradient(
      165.41deg,
      #fadcd7 0%,
      #f8f5ff 23.65%,
      #ffffff 54.66%,
      #f6f3fe 80.95%,
      #ffd4d8 100.92%
    );
  }

  &__accent {
    color: $color-surface-950;
  }

  &__headline {
    color: $color-text-50;

    &--light {
      color: #171321;
    }
  }
}

.kc-hero-list {
  padding: $spacing-48 $spacing-32;
  position: relative;
  z-index: 99;
  * {
    position: relative;
    z-index: 1;
  }

  &--light {
    &::after {
      background: linear-gradient(#ffffff, #ffffff) padding-box,
        linear-gradient(90deg, #e2b6f1 0%, #7759c2 100%) border-box;
    }

    &::before {
      background: linear-gradient(#f6f3fe, #f6f3fe) padding-box,
        linear-gradient(90deg, #e2b6f1 0%, #7759c2 100%) border-box;
    }
  }

  &--dark {
    &::after {
      background: linear-gradient(105.1deg, #000001 0%, #140123 86.48%)
          padding-box,
        linear-gradient(90deg, #e2b6f1, #7759c2) border-box;
    }

    &::before {
      background: linear-gradient(105.1deg, #000001 0%, #140123 86.48%)
          padding-box,
        linear-gradient(90deg, #e2b6f1, #7759c2) border-box;
    }
  }

  @media screen and (max-width: $breakpoint-sm) {
    margin-right: $spacing-16;
  }

  &::before,
  &::after {
    transform: translateZ(-1px);
    content: '';
    position: absolute;
    z-index: -1;
    top: 0;
    right: 0;
    width: 100%;
    height: 100%;
    border: 2.25px solid transparent;
    border-radius: 8px 8px 90px 8px;
  }
  &:before {
    top: 28px;
    right: -24px;
  }
  @media screen and (max-width: $breakpoint-sm) {
    margin-top: $spacing-48;
  }

  &__heading {
    color: $color-text-50;
    padding-bottom: $spacing-24;

    &--light {
      color: #171321;
    }
  }

  &__item {
    display: flex;
    line-height: 1.25;
    color: $color-text-50;
    padding-bottom: $spacing-24;
    align-items: flex-start;

    &--light {
      color: #171321;
    }
  }

  &__icon {
    color: #a989f5;
    margin-right: 12px;
    width: 24px !important;
    height: 24px !important;
    :deep svg {
      stroke: #a989f5;
      fill: none;
      stroke-miterlimit: 10;
      stroke-width: 2;
    }
  }
}
</style>
